SystemOrganization addCategory: #STTutTodoApp!
SystemOrganization addCategory: #'STTutTodoApp-UserStories'!
SystemOrganization addCategory: #'STTutTodoApp-StepComponents'!

ACUserStory subclass: #ACToDoApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!ACToDoApp class methodsFor: 'initialize-release' stamp: 'fg 7/1/2010 12:51'!
givenDict
	
	^ super givenDict at: 'I have a web site' put: [:aString :testObject| 
		WASwazooAdaptor startOn: 9999. 
		ACTestRootComponent registerApplication.
		(Delay forMilliseconds: 500) wait.
			
		testObject wrapper port: 9999.
		testObject superSetUp.
		];
		yourself! !

!ACToDoApp class methodsFor: 'initialize-release' stamp: 'fg 7/1/2010 12:51'!
initialize
	
	super initialize.
	self userStoryString: 'AC ToDo App
In order to get my things done
As a internet user
I want to have my list of to-dos online'. ! !

!ACToDoApp class methodsFor: 'as yet unclassified' stamp: 'topa 7/1/2010 14:21'!
libraries

	^ {MethodContainer}! !

!ACToDoApp class methodsFor: 'initialize-release' stamp: 'fg 7/1/2010 12:51'!
tearDowns

	^ super tearDowns at: '*' put: [:testObject |
		| adaptor |
		"WAAdmin unregister: 'ACTest'."
		WADispatcher default unregister: 'ACTest'.
		adaptor := WAAdmin serverAdaptors detect: [:a | a port = 9999] ifNone: [nil].
		adaptor ifNotNil: [:a|
			a isRunning ifTrue: [ a stop ].
			(Delay forMilliseconds: 250) wait.
			(a isRunning or: [a isStopping]) ifTrue: [a kill]	].
		testObject wrapper port: nil.];
		yourself! !

!ACToDoApp class methodsFor: 'initialize-release' stamp: 'fg 7/1/2010 12:51'!
thenDict
	
	^ super thenDict at: 'I see "*"' put: [:aString :testObject| |subString|
				subString:= aString copyFrom: 8 to: aString size - 1.
				testObject
					assert: (testObject browser textExists: subString)];
			yourself! !

!ACToDoApp class methodsFor: 'initialize-release' stamp: 'fg 7/1/2010 12:51'!
whenDict
	
	^ super whenDict at: 'I go to the web site' put: [:aString :testObject| ];
		yourself! !

!ACToDoApp methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:51'!
create Task
Given I am logged in
When I click on "New Task"
Then I see "Editing Task"! !

!ACToDoApp methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:51'!
login
Given I have registered
When I enter "username" as username
And I enter "password" as password
And I click "Login"
Then I see my list of tasks! !

!ACToDoApp methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:51'!
Select task
Given I am logged in
And I have a Task
When I click on "edit"
Then I see "Editing task"! !

WAComponent subclass: #StListComponent
	instanceVariableNames: 'items filterBlock sortBlock renderItemBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
filterBlock
	^ filterBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
filterBlock: anObject
	filterBlock := anObject! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
items
	^ items! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
items: anObject
	items := anObject! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:28'!
renderContentOn: html

	html table: [(self sortBlock
		value: (self filterBlock value: self items))
		do: [:item | html tableRow: [self renderItemBlock
							value: item
							value: html]]].! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
renderItemBlock
	^ renderItemBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
renderItemBlock: anObject
	renderItemBlock := anObject! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
sortBlock
	^ sortBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:26'!
sortBlock: anObject
	sortBlock := anObject! !

WAComponent subclass: #StLoggedInComponent
	instanceVariableNames: 'menuComponent listComponent taskEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:19'!
children

	^ Array with: self menuComponent with: self listComponent! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'mp 4/22/2010 12:31:40.824'!
createNewTask

	(self call: self taskEditor newTask) ifFalse: [^ self].
	self session database
		addTask: self taskEditor task
		toUser: self session user.! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'mp 4/22/2010 11:16:43.297'!
editTask: aTask
	
	self taskEditor task: aTask copy.
	(self lightbox: self taskEditor) ifFalse: [^ self].
	aTask copyFrom: self taskEditor task.
	self session database save: aTask.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:30'!
initialize

	super initialize.
	self
		initializeMenuComponent;
		initializeListComponent.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 14:22'!
initializeListComponent

	self listComponent: StListComponent new.
	self listComponent
		sortBlock: [:items |
			items sortBy: [:a :b | a deadline < b deadline]];
		renderItemBlock: [:task :html |
			self renderTask: task asRowOn: html];
		items: self session user tasks.
	self showPendingTasks.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 12:32'!
initializeMenuComponent

	self menuComponent:(StMenuComponent new
		addEntry: 'All' withAction: [self showAllTasks];
		addEntry: 'Completed' withAction: [self showCompletedTasks];
		addEntry: 'Pending' withAction: [self showPendingTasks];
		addEntry: 'Missed' withAction: [self showMissedTasks];
		addEntry: 'New Task' withAction: [self createNewTask];
		addEntry: 'Logout' withAction: [self session logout. self answer: true];
		yourself).! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:19'!
listComponent
	^ listComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:19'!
listComponent: anObject
	listComponent := anObject! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:18'!
menuComponent
	^ menuComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:18'!
menuComponent: anObject
	menuComponent := anObject! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 14:35'!
renderCheckboxWith: aTask on: html

	| updater |
	updater := html updater
		id: 'list';
		callback: [:renderer |
			aTask completed: aTask completed not.
			renderer render: self listComponent];
		yourself.
	html checkbox
		onClick: updater;
		value: aTask completed.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'mp 4/22/2010 12:24:54.458'!
renderContentOn: html

	html div
		class: 'generic';
		with:[
			html heading: 'ToDo-List of ', self session user userName.
			html div
				class: 'menu';
				with: self menuComponent.
			html div
				class: 'list';
				id: 'list';
				with: self listComponent].! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 14:44'!
renderInPlaceEditorWith: aTask on: html

	| editor |
	editor := html inPlaceEditor
		cancelControl: false;
		triggerInPlaceEditor: [:value | aTask taskName: value];
		callback: [:renderer | renderer render: aTask taskName];
		yourself.
	html div
		script: editor;
		with: aTask taskName.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 14:45'!
renderTask: aTask asRowOn: html

	html tableData: [html
		tableData: [self renderCheckboxWith: aTask on: html];
		tableData: aTask deadline asString;
		tableData: [self renderInPlaceEditorWith: aTask on: html];
		tableData: aTask taskDescription;
		tableData: [html anchor
					callback: [self editTask: aTask];
					with: 'edit']].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showAllTasks

	self listComponent
		filterBlock: [:items | items].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showCompletedTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item completed]].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:32'!
showMissedTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item isMissed]].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showPendingTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item isPending]].! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:06'!
taskEditor
    
	^ taskEditor ifNil: [taskEditor := StTaskEditor new]! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:03'!
taskEditor: anObject
	taskEditor := anObject! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:51'!
testTasks
	^ OrderedCollection
		with: (StTask new
			deadline: Date yesterday;
			completed: false;
			taskName: 'Missed task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: false;
			taskName: 'Pending task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: true;
			taskName: 'Already completed task')! !

WAComponent subclass: #StLoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:51'!
applicationName

	^ StToDoLibrary applicationName ! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:07'!
email
	^ email! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:07'!
email: anObject
	email := anObject! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:36'!
hashPassword: aString

	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].
	! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:31'!
loginFailed

	self messageComponent errorMessage: 'Login failed.'.! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:56'!
messageComponent

	^ messageComponent ifNil: [messageComponent := StMessageComponent new]! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:07'!
messageComponent: anObject
	messageComponent := anObject! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:07'!
password
	^ password! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:07'!
password: anObject
	password := anObject! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:32'!
registerUser
	
	self answer: #registerUser.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:02'!
renderContentOn: html
	html div
	class: 'generic';
	with: [
		html
			heading: self applicationName;
			render: self messageComponent;
			text: 'Please login with email and password:';
			form: [
				self
					renderTextInputOn: html;
					renderPasswordInputOn: html;
					renderLoginButtonOn: html;
					renderSignUpAnchorOn: html]].! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:15'!
renderLoginButtonOn: html

	html submitButton
		callback: [self validateLogin];
		text: 'Login'.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:15'!
renderPasswordInputOn: html

	html passwordInput
		callback: [:value | self password: (self hashPassword: value)];
		value: ''.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:16'!
renderSignUpAnchorOn: html

	html paragraph with: [html anchor
		callback: [self registerUser];
		with: [html text: 'Sign up for the ', self applicationName]].! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:14'!
renderTextInputOn: html

	html textInput
		on: #email of: self;
		value: ''.
	html space.! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:29'!
validateLogin

	| user |
	user := self session findUserByEmail: self email.
	(user notNil and: [user password = self password])
	ifTrue: [self answer: user]
	ifFalse: [self loginFailed].! !

WAComponent subclass: #StMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMenuComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:21'!
addEntry: aString withAction: aBlock
	
	^ self entries add: aString -> aBlock! !

!StMenuComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:20'!
entries
	^ entries! !

!StMenuComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:20'!
entries: anObject
	entries := anObject! !

!StMenuComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:23'!
initialize

	super initialize.
	self entries: OrderedCollection new.! !

!StMenuComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:22'!
renderContentOn: html

	self entries
		do: [:entry |
			html anchor
				callback: entry value;
				with: entry key]
		separatedBy: [html space].! !

WAComponent subclass: #StMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:17'!
errorMessage: aString

	self
		messageString: aString;
		messageType: 'error';
		wasShown: false.! !

!StMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:18'!
infoMessage: aString

	self
		messageString: aString;
		messageType: 'info';
		wasShown: false.! !

!StMessageComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 13:15'!
initialize

	super initialize.
	self wasShown: true.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:15'!
messageString
	^ messageString! !

!StMessageComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:15'!
messageString: anObject
	messageString := anObject! !

!StMessageComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:16'!
messageType
	^ messageType! !

!StMessageComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:16'!
messageType: anObject
	messageType := anObject! !

!StMessageComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 13:18'!
renderContentOn: html

	self wasShown ifTrue: [^ self].
	html div
		class: self messageType, 'Message';
		with: self messageString.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:16'!
wasShown
	^ wasShown! !

!StMessageComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:16'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #StRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRegisterComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:01'!
hashPassword: aString
	
	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].! !

!StRegisterComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 12:52'!
initialize

	super initialize.
	self user: StUser new.
	! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:56'!
messageComponent

	^ messageComponent ifNil: [messageComponent := StMessageComponent new]! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:56'!
messageComponent: anObject
	messageComponent := anObject! !

!StRegisterComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 16:34'!
registerUser
    
    self user userName isEmptyOrNil
        ifTrue: [^ self messageComponent
            infoMessage: 'Please choose a username!!'].
    self user email isEmptyOrNil
        ifTrue: [^ self messageComponent
            infoMessage: 'Please enter your email address!!'].
    (self session findUserByEmail: self user email)
        ifNotNil: [^ self messageComponent
            errorMessage: 'The email address is already registered!!'].
    self user password = 0
        ifTrue: [^ self messageComponent
            infoMessage: 'Please choose a password!!'].
    self user password = self repeatedPassword
        ifFalse: [^ self messageComponent
            infoMessage: 'Your repeated password does not match!!'].
    self session database addUser: self user.
    self answer: self user.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:58'!
renderCancelButtonOn: html
	
	html submitButton
		callback: [self answer: nil];
		text: 'Cancel'.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:54'!
renderContentOn: html

	html div
		class: 'generic';
		with: [
			html
				heading: 'Register';
				render: self messageComponent;
				form: [
					html table: [
						self
							renderUsernameTextInputOn: html;
							renderEmailTextInputOn: html;
							renderPasswordTextInputOn: html;
							renderRepeatedPasswordTextInputOn: html.
						html tableRow: [
							html
								tableData;
								tableData: [
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html]]]]].
	! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:59'!
renderEmailTextInputOn: html

    html tableRow: [
        html
            tableData: 'Email';
            tableData: [
                html textInput
                    callback: [:value | self user email: value];
                    value: self user email]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 13:00'!
renderPasswordTextInputOn: html
    
	html tableRow: [
        html
            tableData: 'Password';
            tableData: [
                html passwordInput
                    callback: [:value | 
                        self user password: (self hashPassword: value)]]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 13:00'!
renderRepeatedPasswordTextInputOn: html
  
    html tableRow: [
        html
            tableData: 'Repeat password';
            tableData: [
                html passwordInput
                    callback: [:value | 
                        self repeatedPassword: (self hashPassword: value)]]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:57'!
renderSubmitButtonOn: html

	html submitButton
		callback: [self registerUser];
		text: 'Register'.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:59'!
renderUsernameTextInputOn: html

	html tableRow: [
		html
		tableData: 'Username';
		tableData: [
			html textInput
				callback: [:value | self user userName: value];
				value: self user userName]].! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:51'!
repeatedPassword
	^ repeatedPassword! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:51'!
repeatedPassword: anObject
	repeatedPassword := anObject! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:51'!
user
	^ user! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:51'!
user: anObject
	user := anObject! !

WAComponent subclass: #StTaskEditor
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTaskEditor methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:53'!
initialize

	super initialize.
	self task: StTask new.! !

!StTaskEditor methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:14'!
newTask

	self task: StTask new.! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:58'!
renderButtonsOn: html

	html
		tableData;
		tableData: [
			html submitButton
				callback: [self answer: true];
				value: 'Save'.
			html submitButton
				callback: [self answer: false];
				value: 'Cancel'].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:57'!
renderCompletedSelectionOn: html

	html
		tableData: [html text: 'Completed: '];
		tableData: [
			html select
				add: true;
				add: false;
				on: #completed of: self task;
				labels: [:value |
					value
						ifTrue: ['yes']
						ifFalse: ['no']]].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:55'!
renderContentOn: html

	html div
		class: 'generic lightbox';
		with: [
			html heading: 'Editing task'.
			html form: [
				html table: [
					html
						tableRow: [self renderNameInputOn: html];
						tableRow: [self renderDescriptionInputOn: html];
						tableRow: [self renderDateInputOn: html];
						tableRow: [self renderCompletedSelectionOn: html];
						tableRow: [self renderButtonsOn: html]]]].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderDateInputOn: html

	html
		tableData: [html text: 'Deadline: '];
		tableData: [html dateInput on: #deadline of: self task].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderDescriptionInputOn: html

	html
		tableData: [html text: 'Description: '];
		tableData: [html textArea on: #taskDescription of: self task].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderNameInputOn: html

	html
		tableData: [html text: 'Name: '];
		tableData: [html textInput on: #taskName of: self task].! !

!StTaskEditor methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:53'!
task
	^ task! !

!StTaskEditor methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:53'!
task: anObject
	task := anObject! !

ATestCase subclass: #MethodContainer
	instanceVariableNames: 'scenario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-StepComponents'!

!MethodContainer class methodsFor: 'as yet unclassified' stamp: 'topa 7/1/2010 14:28'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:49'!
clickOn: aButton
	"comment stating purpose of message"

	self browser clickOn: aButton.! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:27'!
enterPassword: aPasswordString
	"comment stating purpose of message"
	
	self browser fill: 'passwordField' with: aPasswordString.! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:29'!
enterUsername: aString
	"comment stating purpose of message"

	self browser fill: 'usernameField' with: aString.! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:33'!
haveRegistered
	"comment stating purpose of message"
	
	self registerUser. ! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:36'!
loggedIn
	"comment stating purpose of message"
	
	self browser login.! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:37'!
login: aUsername with: aPassword
	"comment stating purpose of message"

	self browser fill: 'username' with: aUsername.
	self browser fill: 'password' with: aPassword.
	self browser click: 'login'.! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:06'!
registerUser
	"comment stating purpose of message"
! !

!MethodContainer methodsFor: 'accessing' stamp: 'topa 7/1/2010 14:18'!
scenario

	^scenario! !

!MethodContainer methodsFor: 'accessing' stamp: 'topa 7/1/2010 14:18'!
scenario: anObject

	scenario := anObject! !

!MethodContainer methodsFor: 'as yet unclassified' stamp: 'fg 7/1/2010 12:44'!
see: aString
	"comment stating purpose of message"

	self assert: (self browser textExists: aString).! !

WATask subclass: #StRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRootTask class methodsFor: 'testing' stamp: 'micper 4/9/2008 11:39'!
canBeRoot

	^ true! !

!StRootTask class methodsFor: 'testing' stamp: 'mp 4/22/2010 11:13:52.391'!
initialize
	"self initialize"
	(self registerAsApplication: 'todo')
		addLibrary: SUDeploymentLibrary;
		addLibrary: PTDeploymentLibrary;
		addLibrary: StToDoLibrary;
		preferenceAt: #sessionClass put: StSession.! !

!StRootTask methodsFor: 'processing' stamp: 'micper 4/9/2008 11:58'!
go
	| loginAnswer user |
	loginAnswer := self call: StLoginComponent new.
	loginAnswer = #registerUser
		ifTrue: [user := self call: StRegisterComponent new]
		ifFalse: [user := loginAnswer].
	user ifNotNil: [
		self session login: user.
		self call: StLoggedInComponent new].! !

WAFileLibrary subclass: #StToDoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StToDoLibrary class methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:50'!
applicationName

	^ 'ToDo Application'! !

!StToDoLibrary methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:53'!
selectorsToInclude

	^ #( todoCss )! !

!StToDoLibrary methodsFor: 'uploaded' stamp: 'micper 4/9/2008 14:58'!
todoCss
    ^ '
body {
    font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
    
.generic {
    font-family: Geneva, Arial, Helvetica, sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 14px;
    color : #663300;
    padding: 20px;
    margin-top: 20px;
    margin-left: 20px;
    border: 1px solid #663300;
    width: 500px;
}

.lightbox {
    background-color:#FFFFFF;
}

.errorMessage {
    background-color: #ffb0b0;
    border: 1px solid #ee0000;
    padding: 5px;
    margin-bottom: 10px;
}

.infoMessage {
    background-color: #fbffcc;
    border: 1px solid #eda33a;
    padding: 5px;
    margin-bottom: 10px;
}

a {
    color : #663300;
    text-decoration: underline;
}'! !

Object subclass: #StImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Users WriteMutex'
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:10'!
users
	
	^ Users ifNil: [Users := OrderedCollection new]! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:09'!
users: anObject
	Users := anObject! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:12'!
writeMutex
	
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:11'!
writeMutex: anObject
	WriteMutex := anObject! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:17'!
addTask: aTask toUser: aUser

	aUser addTask: aTask.
	self saveImage.
	^ aTask! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:16'!
addUser: aUser

	self class users add: aUser.
	self saveImage.
	^ aUser! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:18'!
connectionFailed

	^ false! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:18'!
disconnect! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:17'!
findUserByEmail: anEmail

	^ self class users
		detect: [:each | each email = anEmail]
		ifNone: [nil]! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:18'!
save: anObject! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:14'!
saveImage

	self class writeMutex critical: [self saveImageWithoutMonitor].! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:11'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession.! !

Object subclass: #StTask
	instanceVariableNames: 'completed deadline taskDescription id taskName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
completed
	^ completed! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
completed: anObject
	completed := anObject! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
deadline
	^ deadline! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
deadline: anObject
	deadline := anObject! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
id
	^ id! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
id: anObject
	id := anObject! !

!StTask methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:13'!
initialize

	self
		deadline: Date tomorrow;
		completed: false.! !

!StTask methodsFor: 'comparing' stamp: 'micper 4/9/2008 10:12'!
isMissed

	^ self completed not and: [self deadline < Date today]! !

!StTask methodsFor: 'comparing' stamp: 'micper 4/9/2008 10:11'!
isPending

	^ self completed not and: [self deadline >= Date today]! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
taskDescription
	^ taskDescription! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
taskDescription: anObject
	taskDescription := anObject! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
taskName
	^ taskName! !

!StTask methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:11'!
taskName: anObject
	taskName := anObject! !

Object subclass: #StUser
	instanceVariableNames: 'id userName email tasks password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:09'!
addTask: aTask
	
	^ self tasks add: aTask! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:07'!
email
	^ email! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:07'!
email: anObject
	email := anObject! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:07'!
id
	^ id! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:07'!
id: anObject
	id := anObject! !

!StUser methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:08'!
initialize
	
	self tasks: OrderedCollection new.! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:08'!
password
	^ password! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:08'!
password: anObject
	password := anObject! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:08'!
tasks
	^ tasks! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:08'!
tasks: anObject
	tasks := anObject! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:07'!
userName
	^ userName! !

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:07'!
userName: anObject
	userName := anObject! !

WASession subclass: #StSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StSession methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:20'!
database
	^ database! !

!StSession methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:20'!
database: anObject
	database := anObject! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 14:28'!
findUserByEmail: anEmail

	^ self database findUserByEmail: anEmail! !

!StSession methodsFor: 'initializing' stamp: 'micper 4/9/2008 14:20'!
initialize
	
	super initialize.
	self database: StImageDatabase new.! !

!StSession methodsFor: 'comparing' stamp: 'micper 4/9/2008 11:22'!
isLoggedIn

	^ self user isNil not! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
login: aUser
	
	self user: aUser.! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
logout

	self user: nil.! !

!StSession methodsFor: 'request handling' stamp: 'micper 4/9/2008 14:29'!
responseForRequest: aRequest

	self database connectionFailed
		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!StSession methodsFor: 'private' stamp: 'micper 4/9/2008 14:21'!
unregistered

	self database disconnect.
	super unregistered.! !

!StSession methodsFor: 'updating' stamp: 'micper 4/9/2008 13:54'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: StToDoLibrary applicationName.! !

!StSession methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:21'!
user
	^ user! !

!StSession methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:21'!
user: anObject
	user := anObject! !
ACToDoApp initialize!
StRootTask initialize!
